> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Update Subnet

PATCH https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/subnet/{subnetId}
Content-Type: application/json

Update an existing Subnet

Org must have a Tenant entity. User must have `FORGE_TENANT_ADMIN` authorization role.


Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/subnet/update-subnet

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/subnet/{subnetId}:
    patch:
      operationId: update-subnet
      summary: Update Subnet
      description: >
        Update an existing Subnet


        Org must have a Tenant entity. User must have `FORGE_TENANT_ADMIN`
        authorization role.
      tags:
        - subpackage_subnet
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: subnetId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Subnet'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SubnetUpdateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    SubnetUpdateRequest:
      type: object
      properties:
        name:
          type: string
        description:
          type: string
      required:
        - name
      description: Request data for updating a Subnet
      title: SubnetUpdateRequest
    SubnetRoutingType:
      type: string
      enum:
        - Public
        - DatacenterOnly
      title: SubnetRoutingType
    SubnetStatus:
      type: string
      enum:
        - Pending
        - Provisioning
        - Ready
        - Deleting
        - Error
      description: Status values for Subnet objects
      title: SubnetStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type: string
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    Deprecation:
      type: object
      properties:
        attribute:
          type:
            - string
            - 'null'
        queryParam:
          type:
            - string
            - 'null'
        endpoint:
          type:
            - string
            - 'null'
        replacedBy:
          type:
            - string
            - 'null'
        takeActionBy:
          type: string
          format: date-time
        notice:
          type: string
      description: Details of a particular deprecation in NCX Infra Controller API
      title: Deprecation
    Subnet:
      type: object
      properties:
        id:
          type: string
          format: uuid
        name:
          type: string
        description:
          type: string
        siteId:
          type: string
          format: uuid
        vpcId:
          type: string
          format: uuid
        tenantId:
          type: string
          format: uuid
        controllerNetworkSegmentId:
          type:
            - string
            - 'null'
          format: uuid
        ipv4Prefix:
          type:
            - string
            - 'null'
          format: ipv4
          description: The prefix that gets assigned to the subnet if ipv4 block is chosen
        ipv4BlockId:
          type:
            - string
            - 'null'
          format: uuid
        ipv4Gateway:
          type:
            - string
            - 'null'
          format: ipv4
        ipv6Prefix:
          type:
            - string
            - 'null'
          format: ipv6
        ipv6BlockId:
          type:
            - string
            - 'null'
          format: uuid
        ipv6Gateway:
          type:
            - string
            - 'null'
          format: ipv6
        mtu:
          type: integer
          description: >-
            Maximum Transmission Unit size in bytes. This property is
            system-determined and read-only.
        prefixLength:
          type: integer
          description: Max value depends on prefix length of parent IP Block
        routingType:
          $ref: '#/components/schemas/SubnetRoutingType'
        status:
          $ref: '#/components/schemas/SubnetStatus'
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
      description: Subnets are network grouping constructs for baremetal machines.
      title: Subnet
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python example-1
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId"

payload = {
    "name": "spark-gpu-subnet",
    "description": "Subnet for dedicated GPU nodes"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"spark-gpu-subnet","description":"Subnet for dedicated GPU nodes"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId"

	payload := strings.NewReader("{\n  \"name\": \"spark-gpu-subnet\",\n  \"description\": \"Subnet for dedicated GPU nodes\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"spark-gpu-subnet\",\n  \"description\": \"Subnet for dedicated GPU nodes\"\n}"

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"spark-gpu-subnet\",\n  \"description\": \"Subnet for dedicated GPU nodes\"\n}")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId', [
  'body' => '{
  "name": "spark-gpu-subnet",
  "description": "Subnet for dedicated GPU nodes"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"spark-gpu-subnet\",\n  \"description\": \"Subnet for dedicated GPU nodes\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "spark-gpu-subnet",
  "description": "Subnet for dedicated GPU nodes"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/subnet/subnetId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```